%% Problem 3.4, 3.5 and 3.6

clear all
close all
clc

%global parameters
N = 1e4;        %signal lengths
seg = 256 ;     %segment length
MaxLag = 15;    %delay lag maximum
overl = 0;      %overlap of segments

%generate random processes
x_a = rpiid(N, 'exp');
x_b = rpiid(N, 'nor');

%n_h = 0:1;   %length of impulse response
%n_h = 0:5;
n_h = 0:10;

h = .8.^n_h;
x_c = filter(h,1,x_a);

x_d = filter(h,1,x_b);

[Vmodel,H] = quadnl();
x_e = vkernels_o(x_b,Vmodel);

%input selection
x = x_e;

%----------------------------------------
%% cumulant calculation - Problem 3.4

%2nd order - ACF
c2_x = cumest(x, 2, MaxLag, seg, overl, 'unbiased');

%ACF(0) = variance
sigma_x = sqrt(c2_x(MaxLag+1));

%3rd order cumulant
for k1 = -MaxLag:MaxLag
  c3_x(:,k1+MaxLag+1) = cumest(x, 3, MaxLag, seg, overl, 'unbiased', k1);
end

%Visualization
figure
plot(-MaxLag:MaxLag, c2_x, 'b.-')
grid on
xlabel('k')
ylabel('c_{2,x}[k]')

viscumul3(c3_x, 0, [-MaxLag MaxLag], [-MaxLag MaxLag])
%viscumul3(c3_x, sigma_x)
title('3rd order cumulant')

%------------------------------------------
%% Bispectrum calculation - Problem 3.5

%windowing, use optimal smoothing window
w = gabrrao(MaxLag);
%figure, imagesc(w), axis equal, colorbar

%compute Bispectrum
S3_x = fftshift( fft2(c3_x .* w) );

visbispec3(S3_x)
%visbispec3(S3_x, sigma_x)
title('Bispectrum')


%-------------------------------------------
%% What's flat/zero? - Interpretation

figure
surf(interpn(c3_x,2,'cubic'));
title('3rd order cumulant')
zlim([0 20])   %select limits according to plot

figure
surf(interpn(abs(S3_x),2,'cubic'));
title('Bispectrum')
zlim([0 250])

%% Problem 3.6 - Hinichs test procedure for Gaussianity/Linearity of a process
[sg, sl] = glstat(x);
Pfa = sg(3)
R_est = sl(1)
R_the = sl(2)

